; ; ; ; MIT License
; ; ; ; 
; ; ; ; Copyright (c) 2021 Ramiro Hernán García Iten / Raúl Ripoll Pérez / Alexandru Marius Cozma
; ; ; ; 
; ; ; ; Permission is hereby granted, free of charge, to any person obtaining a copy
; ; ; ; of this software and associated documentation files (the "Software"), to deal
; ; ; ; in the Software without restriction, including without limitation the rights
; ; ; ; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; ; ; ; copies of the Software, and to permit persons to whom the Software is
; ; ; ; furnished to do so, subject to the following conditions:
; ; ; ; 
; ; ; ; The above copyright notice and this permission notice shall be included in all
; ; ; ; copies or substantial portions of the Software.
; ; ; ;
; ; ; ; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; ; ; ; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; ; ; ; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; ; ; ; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; ; ; ; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; ; ; ; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; ; ; ; SOFTWARE.

; ; ; ; ----------------- AUTHORS ------------------
; ; ; ;     Ramiro Hernán García Iten: rhgi1@alu.ua.es
; ; ; ;     Raúl Ripoll Pérez: rrp42@alu.ua.es
; ; ; ;     Alexandru Marius Cozma: amc246@alu.ua.es
; ; ; ; 
; ; ; ; Art by Sara Alfosea - IG: @Slinfir
; ; ; ; ---------------------------------------------

; ; ; ; Third Party source code used
; ; ; ; ----------------------------
; ; ; ; CPCtelera - owned by ronaldo / (Cheesetea, Fremos, ByteRealms) - GNU Lesser General Public License.


;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine 
;;  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"

;;; ==========================================
;;; ==========================================
;;; GAME MANAGER
;;; ==========================================
;;; ==========================================

; Inicializa todos los managers y sistemas
man_game_init::
   call  man_entity_init   ; Inicializa el manager de entidades

   call  sys_physics_init  ;      "     "  sistema de físicas

   xor   a
   ld    (levelProgress), a

   ld    a, (currentLevel)
   cp    #5
   jr    nz, allEnemies
      ld    a, #e_enemy_all
      ld    (currentEnemy), a
 allEnemies:
   
   add   #0x08
   ld    (starLocation_C0), a
   ld    (starLocation_80_1), a
   ld    (starLocation_80_2), a
   ld    (starLocation_80_3), a

   cpctm_setBorder_asm HW_BLACK
   call  sys_render_init
   ret

; Llama a todos los managers y sistemas necesarios para actualizar los datos
man_game_update::
   call  sys_input_update      ; Comprueba las teclas pulsadas
   call  sys_physics_jump      ; Controla el salto
   call  sys_physics_update    ; Actualiza las posiciones según sus velocidades
   call  sys_collision_update  ; Sistema de colisiones
   call  sys_physics_wind      ; Actualiza las posiciones por el wind
   ret

; Llama a todos los managers y sistemas para renderizar
man_game_render::
   call  man_entity_getArray
   call  sys_render_update
   ret

man_game_checkEnd::
   ld    a, (levelProgress)
   cp    #levelEnd
   ret   nz
      ld    a, (currentLevel)    ; Pasamos de nivel si hemos llegado al levelEnd
      inc   a
      ld    (currentLevel), a

      ld    a, (currentEnemy)
      sla   a
      ld    (currentEnemy), a

      pop   af
      ld    hl, #level_win
      jp    (hl)
